#pragma once

#include "Entity.h"

class QuestReward : public virtual Framework::ReferenceCounter
{
private:
	Framework::Text rewardId;

public:
    QuestReward(Framework::Text rewardId);

    virtual void giveReward(Entity* zTargetEntity) = 0;
    virtual Framework::JSON::JSONObject* getAsJSON() const = 0;

    const Framework::Text& getRewardId() const;
};

class QuestRewardItem : public QuestReward
{

};